Unit Main;

(******************************************************************************)
(* Fusion Folder Keeper - Transpear Software                                  *)
(******************************************************************************)
{                                                                              }
{ VERSION      : 1.0                                                           }
{ AUTHOR       : Kelvin Westlake                                               }
{ CREATED      : 14 Semptember 2000                                            }
{ WEBSITE      : http://www.Transpear.cjb.net                                  }
{ EMAIL        : KWestlae@yahoo.com                                            }
{ Dependancies : FormEx Component                                              }
{                Icon Control Componet Lib.  (both are included+free)          }
{                                                                              }
{ NOTES:                                                                       }
{ I am going to start following the examples of other, all my classes will     }
{ begin with the Extension TF (Transpear Fusion) from now on, I will register  }
{ this will borland ASAP.                                                      }
{                                                                              }
{ This program is released with source just to show people the high of quality }
{ of freeware components that are available for delphi, not to show my code off}
{ but the shear quality of the FormEx (tasktray+form handler) and the Icon     }
{ list box that, in my opinion they are better than similar that come with     }
{ commercial packages such as AHM Triton. ( although these are supberb)        }
{                                                                              }
{ All forms (Editor+About) are called dynamically, so you will not find them   }
{ in the project manager, you will need to go to the file menu.  This is the   }
{ time I have tried this method, I was hoping it might free up some memory, if }
{ u have any tips for memory handling then please let me know as a blank delphi}
{ application takes up 1.2Mb of RAM on my system (not very good for Tray Apps).}
{                                                                              }
{ Sorry if my comments are long winded, but it was recently pointed out to me  }
{ that my previous attempts were not adequate enough.                          }
{                                                                              }
{ Please read the enclosed text files                                          }
{******************************************************************************}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Trayicon, Menus, StdCtrls, ImgList, FormEx, ExtCtrls, ShellAPI,FileCtrl;



  Type MenuItemsRec = Record             // all the info we need :)
       Name      : String [30];
       Path      : String [255];
       IconPath  : String [255];
       IconIndex : Integer;
     End;


type
  TtfFolderKeeper = class(TForm)
    FolderMenu: TPopupMenu;
    FormEx1: TFormEx;
    IconList: TImageList;
    ListBoxMenu: TPopupMenu;
    AddPaths1: TMenuItem;
    HomepageItem: TMenuItem;
    EMailUsItem: TMenuItem;
    About1: TMenuItem;
    N1: TMenuItem;             // Menu Seperator 1
    QuitItem: TMenuItem;
    N2: TMenuItem;             // Menu Seperator 2
    procedure FormCreate(Sender: TObject);

    procedure FolderExecute(Sender: TObject);

    procedure QuitButClick(Sender: TObject); // Control menu handlers.
    procedure QuitItemClick(Sender: TObject);
    procedure EMailUsItemClick(Sender: TObject);
    procedure HomepageItemClick(Sender: TObject);
    procedure AddPaths1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
   DataFilePath : String[255];
  public
    Procedure ReadConfig(Path : String);
  end;

var
  tfFolderKeeper: TtfFolderKeeper;

implementation

Uses Icons, Editor,About;

{$R *.DFM}

// If given a path say 'c:\windows\system32\shell.exe' it try to split
// the path up and return just the paths directory ie 'c:\windows\system32'
// there is probally an API call to this but I wrote this fuction more
// than 7 years ago in TP7 :)
Function SplitPath(Orig : String):String;
Var T         : string[255];
    found     : boolean;
    count     : Integer;
    Seperator : integer;
Begin
  T:=Orig;
  found:=false;
  Seperator:=Length(Orig);
  count:=0;
Repeat
 Dec(Seperator);
   If Orig[Seperator]=':' THEN
   Begin
     found:=true;
     Inc(Seperator);
   End;
   If Orig[Seperator]='\' THEN found:=true;
UNTIL (Found)  OR (Seperator=0);
 Repeat
   T[count]:=Orig[count];
   Inc(Count);
 Until Count=Seperator;
  SetLength(T,Count-1);
  SplitPath:=T;
End;




////////////////////////////////////////////////////////////////////////////////
/// Config Reading Routine
///
/// the data file is look for in the program run directory, once a Record has
/// been read a menu item is created for it. the execute path is stored in the
/// item.hint, as this is never displayed we can make use for them.
/// if no icon has been set the .IconPath will read 'NONE' and a default folder
/// Icon will be displayed.

Procedure TtfFolderKeeper.ReadConfig(Path : String);
var f    : File oF MenuItemsRec;
    Count : Integer;
    NewItem : TMenuItem;
    Icon : TIcon;
    Index : Integer;
     List : MenuItemsRec;
Begin
AssignFile(f,Path);
{$I-}
Reset(f);
{$I+}
IF IOResult<>0 THEN Exit;
For Count:=1 To  FileSize(f) Do
Begin
  NewItem:=TMenuItem.create(FolderMenu);
  Read(f,List);
  IF List.IconPath<>'NONE' THEN
  Begin
   Icon:=ExtractIconFromFile(List.IconPath,List.IconIndex);
   Index:=IconList.AddIcon(Icon);
  end
  Else Index:=0;
  NewItem.caption:=List.Name;
  NewItem.Hint:=List.Path;
  NewItem.ImageIndex:=Index;
  NewItem.OnClick:=FolderExecute;
  FolderMenu.Items.Add(NewItem);
  End;
 CloseFile(f);
End;



///////////////////////////////////////////////////////////////////////////////
/// Tasktray Menu handling routines.

procedure TtfFolderKeeper.FolderExecute(Sender: TObject);
Var Path : String;
begin
  Path:=(Sender As TMenuItem).Hint;
  shellexecute(application.Handle,'open',PChar(Path),nil,nil,sw_show);
end;



procedure TtfFolderKeeper.QuitButClick(Sender: TObject);
begin
 Application.Terminate;
end;



procedure TtfFolderKeeper.QuitItemClick(Sender: TObject);
begin
Application.Terminate;
end;



procedure TtfFolderKeeper.EMailUsItemClick(Sender: TObject);
begin
  shellexecute(application.Handle,'open','mailto:kwestlake@yahoo.com',nil,nil,sw_show);
end;



procedure TtfFolderKeeper.HomepageItemClick(Sender: TObject);
begin
 shellexecute(application.Handle,'open','http://www.transpear.cjb.net',nil,nil,sw_show);
end;


// Although ShowModal is used, we are creating these items dynamically so if the
// user clicks TrayIcon to many times more than 1 box edit box will pop-up, so
// must disable access to the tasktray for the Effect of Modal to work.
// this is the first time I have used this method, is this a problem with
// the Tray component??
procedure TtfFolderKeeper.AddPaths1Click(Sender: TObject);
Var KeeperEditor : TTFKeeperEditor;
begin
 FormEx1.TrayIcon.Enabled:=False;
 KeeperEditor:=TTFKeeperEditor.Create(Self);
 IF KeeperEditor.Execute(DataFilePath) THEN
 Begin
   FolderMenu.Items.Clear;   // Out with the old
   ReadConfig(DataFilePath);   // and in with the new :)
 End;
 KeeperEditor.free;
 FormEx1.TrayIcon.Enabled:=True;
end;


// see above procedure for exmplanation.
procedure TtfFolderKeeper.About1Click(Sender: TObject);
Var AboutDlg : TTFAbout;
begin
 FormEx1.TrayIcon.Enabled:=False;
 AboutDlg:=TtfAbout.Create(Self);
 AboutDlg.Execute;
 AboutDlg.Free;
 FormEx1.TrayIcon.Enabled:=True;
end;



////////////////////////////////////////////////////////////////////////////////
//// Main Execute + Property calls

procedure TtfFolderKeeper.FormCreate(Sender: TObject);
begin
Width:=0;
Height:=0;

DataFilePath:=SplitPath(ParamStr(0))+'\Paths.dat';
ReadConfig(DataFilePath);
Application.Title:='Fusion Folder Keeper (c) 2000 Transpear Software';
FormEx1.TrayIcon.IconVisible:=True;
SetWindowLong( application.handle, GWL_EXSTYLE,
                GetWindowLong( application.handle, GWL_EXSTYLE )
                   or WS_EX_TOOLWINDOW and not WS_EX_APPWINDOW );
end;


end.

